package com.bazaarvoice.jolt.common.reference;

/**
 * Reference is used by Shiftr when lookup up values from a WalkedPath (list of LiteralPathElements).
 *
 * Ex given a WalkedPath like :
 *  WalkedPath : [
 *    LiteralPathElement : [ "cdv-Tuna", "Tuna" ],   // This LiteralPathElement would be generated by a match of "cdv-*" and the key "cdv-Tuna"
 *    LiteralPahtElement : [ "Delicious" ]
 *  ]
 *
 *   &,  &0, &(0,0) would all evaluate to "Delicious"
 *   &1, &1, &(1,0) would all evaluate to "cdv-Tuna"
 *   &(1,1) would evaluate to "Tuna"
 *
 * The "canonical form" is "C(x,y)", where :
 *  C : the character used to determine the type of Reference
 *  x : pathIndex : which is how far up the walkedPath the look
 *  y : keyGroup : where 0 is the whole key, and 1 thru n smaller captured parts of the key
 *
 */
public interface PathAndGroupReference extends PathReference {

    public int getKeyGroup();
}
